pwd
itr=1
root_path=./dataset/
pred_len=96
seq_len=336
label_len=96
stride=8
patch_len=16

traindata_path=captioned_public/ETTh1_train_dataset.pth
valdata_path=captioned_public/ETTh1_val_dataset.pth
data=Etth1
dataMMD=Etth1_MMD

for seed in 42 27 10
do
    python run_unimodal.py --is_training=1 --model_id=test_DLinear --model=DLinear --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len 

    python run_unimodal.py --is_training=1 --model_id=test_FITS --model=FITS --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_PatchTST --model=PatchTST --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_iTransformer --model=iTransformer --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_multimodal.py --is_training=1 --model_id=test_TimeMMD --model=iTransformer --task_name=long_term_forecast --data=$dataMMD --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_timeLLM.py --is_training=1 --model_id=test_TimeLLM --model=TimeLLM --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len
done

traindata_path=captioned_public/ETTh2_train_dataset.pth
valdata_path=captioned_public/ETTh2_val_dataset.pth
data=Etth2
dataMMD=Etth2_MMD

for seed in 42 27 10
do
    python run_unimodal.py --is_training=1 --model_id=test_DLinear --model=DLinear --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_FITS --model=FITS --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_PatchTST --model=PatchTST --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_iTransformer --model=iTransformer --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_multimodal.py --is_training=1 --model_id=test_TimeMMD --model=iTransformer --task_name=long_term_forecast --data=$dataMMD --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_timeLLM.py --is_training=1 --model_id=test_TimeLLM --model=TimeLLM --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len
done

traindata_path=captioned_public/ETTm1_train_dataset.pth
valdata_path=captioned_public/ETTm1_val_dataset.pth
data=Ettm1
dataMMD=Ettm1_MMD

for seed in 42 27 10
do
    python run_unimodal.py --is_training=1 --model_id=test_DLinear --model=DLinear --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len 

    python run_unimodal.py --is_training=1 --model_id=test_FITS --model=FITS --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len 

    python run_unimodal.py --is_training=1 --model_id=test_PatchTST --model=PatchTST --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_iTransformer --model=iTransformer --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len 

    python run_multimodal.py --is_training=1 --model_id=test_TimeMMD --model=iTransformer --task_name=long_term_forecast --data=$dataMMD --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len 

    python run_timeLLM.py --is_training=1 --model_id=test_TimeLLM --model=TimeLLM --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len
done

traindata_path=captioned_public/ETTm2_train_dataset.pth
valdata_path=captioned_public/ETTm2_val_dataset.pth
data=Ettm2
dataMMD=Ettm2_MMD

for seed in 42 27 10
do
    python run_unimodal.py --is_training=1 --model_id=test_DLinear --model=DLinear --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_FITS --model=FITS --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_PatchTST --model=PatchTST --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_unimodal.py --is_training=1 --model_id=test_iTransformer --model=iTransformer --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_multimodal.py --is_training=1 --model_id=test_TimeMMD --model=iTransformer --task_name=long_term_forecast --data=$dataMMD --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len

    python run_timeLLM.py --is_training=1 --model_id=test_TimeLLM --model=TimeLLM --data=$data --seed=$seed --itr=$itr --root_path=$root_path --traindata_path=$traindata_path --valdata_path=$valdata_path --patch_len=$patch_len --stride=$stride --pred_len=$pred_len --seq_len=$seq_len --label_len=$label_len
done